package com.koobietech.eas.service.impl;

import com.koobietech.eas.common.result.PageData;
import com.koobietech.eas.mbg.mapper.EasEduClassroomMapper;
import com.koobietech.eas.mbg.model.EasEduClass;
import com.koobietech.eas.mbg.model.EasEduClassroom;
import com.koobietech.eas.mbg.model.EasEduClassroomExample;
import com.koobietech.eas.service.EasEduClassroomService;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Objects;

@Service
public class EasEduClassroomServiceImpl implements EasEduClassroomService {

    @Resource
    EasEduClassroomMapper easEduClassroomMapper;

    @Override
    public int addClassroom(EasEduClassroom easEduClassroom) {
        easEduClassroom.setCreateTime(new Date());
        easEduClassroom.setModifyTime(new Date());
        return easEduClassroomMapper.insert(easEduClassroom);
    }

    @Override
    public int updateClassroom(EasEduClassroom easEduClassroom) {
        return easEduClassroomMapper.updateByPrimaryKey(easEduClassroom);
    }

    @Override
    public int deleteClassroom(int id) {
        return easEduClassroomMapper.deleteByPrimaryKey(id);
    }

    @Override
    public EasEduClassroom selectClassroomById(Integer id) {
        System.out.println( "ID:" + id );
        return easEduClassroomMapper.selectByPrimaryKey(id);
    }

    @Override
    public List<EasEduClassroom> selectAllClassroom() {
        return easEduClassroomMapper.selectByExample(null);
    }

    @Override
    public PageData selectClassroomByExample(EasEduClassroom easEduClassroom ) {
        EasEduClassroomExample easEduClassroomExample = new EasEduClassroomExample();
        EasEduClassroomExample.Criteria criteria = easEduClassroomExample.createCriteria();
        if (Objects.nonNull(easEduClassroom)){
            if (Objects.nonNull(easEduClassroom.getId())){
                criteria.andIdEqualTo(easEduClassroom.getId());
            }
            if (StringUtils.hasText(easEduClassroom.getName())){
                criteria.andNameLike("%" + easEduClassroom.getName() + "%");
            }
            if (Objects.nonNull(easEduClassroom.getManagerId()) && easEduClassroom.getManagerId() > 0){
                criteria.andManagerIdEqualTo(easEduClassroom.getManagerId());
            }
            if (StringUtils.hasText(easEduClassroom.getAddress())){
                criteria.andAddressLike("%" + easEduClassroom.getAddress() + "%");
            }
            if (StringUtils.hasText(easEduClassroom.getManager())){
                criteria.andManagerLike("%" + easEduClassroom.getManager() + "%");
            }
            if (Objects.nonNull(easEduClassroom.getFloor()) && easEduClassroom.getFloor() > 0){
                criteria.andFloorEqualTo(easEduClassroom.getFloor());
            }
            if (Objects.nonNull(easEduClassroom.getCapacity()) && easEduClassroom.getCapacity() > 0){
                criteria.andCapacityEqualTo(easEduClassroom.getCapacity());
            }
            if (StringUtils.hasText(easEduClassroom.getComment())){
                criteria.andCommentLike("%"+easEduClassroom.getComment()+"%");
            }
            if (StringUtils.hasText(easEduClassroom.getDisabled())){
                criteria.andDisabledLike("%" + easEduClassroom.getDisabled() + "%");
            }
            if (Objects.nonNull(easEduClassroom.getCreateTime())) {
                criteria.andCreateTimeGreaterThan(easEduClassroom.getCreateTime());
            }
            if (Objects.nonNull(easEduClassroom.getModifyTime())) {
                criteria.andCreateTimeGreaterThan(easEduClassroom.getModifyTime());
            }
            if (Objects.nonNull(easEduClassroom.getCreateUid()) && easEduClassroom.getCreateUid() > 0){
                criteria.andCreateUidEqualTo(easEduClassroom.getCreateUid());
            }
        }
        List<EasEduClassroom> easEduClassrooms = easEduClassroomMapper.selectByExample(easEduClassroomExample);
        long l = easEduClassroomMapper.countByExample(easEduClassroomExample);
        return PageData.init(easEduClassrooms,l);
    }
}
